
#define WINVER 0x0500
#define _WIN32_WINNT 0x0400
#define _WIN32_WINDOWS 0x0410
#define _WIN32_IE 0x0400

#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <commctrl.h>
#include <commdlg.h>
#include <tchar.h>
#include <shellapi.h>
#include <Vfw.h>
#include "resource.h"

HINSTANCE g_hInst;
HWND g_hwndMCI = NULL;

BOOL SelectFileDialog(LPTSTR lpFile, HWND hwndOwner)
{
	OPENFILENAME ofn;
	TCHAR szFile[MAX_PATH];
	lstrcpy(szFile, "");
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFile = szFile;
	ofn.hwndOwner = hwndOwner;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = TEXT("Vechny soubory (*.*)\0*.*\0");
	ofn.nFilterIndex = 1;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	if ( !GetOpenFileName(&ofn) )
		return FALSE;
	lstrcpy(lpFile, szFile);
	return TRUE;
}

void OnPlayFile(HWND hwndDlg)
{
	if ( IsWindow(g_hwndMCI) )
	{
		MCIWndStop(g_hwndMCI);
		MCIWndDestroy(g_hwndMCI);
	}
	TCHAR szFile[MAX_PATH];
	if ( !SelectFileDialog(szFile, hwndDlg) )
		return;
	g_hwndMCI = MCIWndCreate(NULL, g_hInst, MCIWNDF_NOPLAYBAR | WS_POPUP | WS_BORDER, szFile);
	MCIWndPlay(g_hwndMCI);
	EnableWindow(GetDlgItem(hwndDlg, IDC_STOP), TRUE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_PAUSE), TRUE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_CONTINUE), TRUE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_PLAY), FALSE);
}


void OnStop(HWND hwndDlg)
{
	MCIWndStop(g_hwndMCI);
	MCIWndDestroy(g_hwndMCI);
	EnableWindow(GetDlgItem(hwndDlg, IDC_STOP), FALSE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_PAUSE), FALSE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_CONTINUE), FALSE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_PLAY), TRUE);
}

void OnPause(HWND hwndDlg)
{
	if ( IsWindow(g_hwndMCI) )
		MCIWndPause(g_hwndMCI);
}

void OnContinue(HWND hwndDlg)
{
	if ( IsWindow(g_hwndMCI) )
		MCIWndPlay(g_hwndMCI);
}

void OnInitDialog(HWND hwndDlg)
{
	EnableWindow(GetDlgItem(hwndDlg, IDC_STOP), FALSE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_PAUSE), FALSE);
	EnableWindow(GetDlgItem(hwndDlg, IDC_CONTINUE), FALSE);
	if ( LoadCursor(NULL, IDC_HAND) ) // IDC_HAND neznaj Win95 a NT
	{
		SetClassLongPtr(GetDlgItem(hwndDlg, IDC_WWW), GCLP_HCURSOR,
			(LONG_PTR)LoadCursor(NULL, IDC_HAND));
		SetClassLongPtr(GetDlgItem(hwndDlg, IDOK), GCLP_HCURSOR,
			(LONG_PTR)LoadCursor(NULL, IDC_HAND));
	}
}

INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hwndDlg, IDOK);
					break;
				case IDC_WWW:
					ShellExecute(NULL, TEXT("open"), 
						TEXT("http://www.radekchalupa.cz"), NULL, NULL, SW_SHOW);
					break;
				case IDC_PLAY:
					OnPlayFile(hwndDlg);
					break;
				case IDC_STOP:
					OnStop(hwndDlg);
					break;
				case IDC_PAUSE:
					OnPause(hwndDlg);
					break;
				case IDC_CONTINUE:
					OnContinue(hwndDlg);
					break;
			}
			break;
		case WM_INITDIALOG:
			OnInitDialog(hwndDlg);
			break;
	}	
	return FALSE;
}

int WINAPI _tWinMain(HINSTANCE hInstance,	HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nCmdShow)
{
	g_hInst = hInstance;
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC = ICC_WIN95_CLASSES;
	if ( !InitCommonControlsEx(&icc) )
	  return -1;
	return (int)DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL,
		(DLGPROC)DialogProc);
}